part of tecfy_core_client_package;

class EntityListTileComponent extends StatelessWidget {
  final Entity entity;
  final Map<String, dynamic> data;
  Property? titleField;
  Property? subTitleField;
  Property? tailField;
  final void Function(Map<String, dynamic>)? onExpandItem;
  final void Function(Map<String, dynamic>?)? onClick;
  final void Function(Map<String, dynamic>?)? onLongClick;

  EntityListTileComponent(this.entity, this.data,
      {this.onClick, this.onExpandItem,this.onLongClick}) {
    // TODO: move these properties to [Entity] class to save calling them everytime need to print list item
    var props =
        entity.gridProperties; //.where((e) => e.dbName != 'active').toList();
    var dis = entity.gridProperties.where((e) => e.isDisplayField).toList();
    props.sort((a, b) => a.gridOrder - b.gridOrder);
    if (dis.length > 0) {
      dis.sort((a, b) => a.gridOrder - b.gridOrder);
      titleField = dis[0];
      props = props.where((e) => e.dbName != titleField?.dbName).toList();
      subTitleField = props.length > 0 ? props[0] : null;
      tailField = props.length > 1 ? props[1] : null;
      if (tailField == null && subTitleField != null) {
        tailField = subTitleField;
        subTitleField = null;
      }
    } else {
      titleField = props.length > 0 ? props[0] : null;
      subTitleField = props.length > 1 ? props[1] : null;
      tailField = props.length > 2 ? props[2] : null;
      if (tailField == null && subTitleField != null) {
        tailField = subTitleField;
        subTitleField = null;
      }
    }
  }

  Widget _getTreeCell() {
    if ((data['_children'] != null && data['_children'].length == 0) ||
        onExpandItem == null)
      return SizedBox(
          width: 30 + (((data['_tree_level'] ?? 0) as num).toDouble() * 10.0));
    return IconButton(
      tooltip: data['_expanded'] == true ? 'Collapse' : 'Expand',
      padding: EdgeInsets.only(
          right: LocalConfigService.isArabic
              ? ((data['_tree_level'] ?? 0) as num).toDouble() * 10.0
              : 0.0,
          left: LocalConfigService.isArabic
              ? 0.0
              : ((data['_tree_level'] ?? 0) as num).toDouble() * 10.0),
      icon: Icon(data['_expanded'] == true ? Icons.remove : Icons.add,
          color: ThemeService.mainColor, size: 15),
      onPressed: () => onExpandItem?.call(data),
    );
  }

  @override
  Widget build(BuildContext context) {
    return ListTile(
      leading: entity.isTree && onExpandItem != null
          ? _getTreeCell()
          : entity.hasPhoto
              ? PhotoViewProperty(data: data[entity.photoPropName].toString())
              : null,
      title: titleField == null
          ? null
          : Padding(
              padding: EdgeInsets.only(
                  right: LocalConfigService.isArabic
                      ? ((data['_tree_level'] ?? 0) as num).toDouble() * 10.0
                      : 0.0,
                  left: LocalConfigService.isArabic
                      ? 0.0
                      : ((data['_tree_level'] ?? 0) as num).toDouble() * 10.0),
              child: titleField!.getDisplayWidget(data,
                  size: 16,
                  color: Colors
                      .black)), //, style:TextStyle(color: data['active'] == false ? Colors.red : Colors.black)),
      subtitle: subTitleField == null
          ? null
          : Padding(
              padding: EdgeInsets.only(
                  right: LocalConfigService.isArabic
                      ? ((data['_tree_level'] ?? 0) as num).toDouble() * 10
                      : 0,
                  left: LocalConfigService.isArabic
                      ? 0
                      : ((data['_tree_level'] ?? 0) as num).toDouble() * 10),
              child: subTitleField!
                  .getDisplayWidget(data, size: 14, color: Colors.black54)),
      trailing: tailField == null
          ? null
          : tailField!.getDisplayWidget(data, size: 10, color: Colors.black87),
      onTap: () => onClick == null ? print('') : onClick?.call(data),
      onLongPress: () => onLongClick?.call(data)
    );
  }
}
