part of tecfy_core_client_package;

class PopupPropertyComponent extends StatefulWidget {
  final Property property;
  final Map<String, dynamic> data;
  const PopupPropertyComponent(
      {Key? key, required this.property, required this.data})
      : super(key: key);

  /// show filed edit on popup
  static Future<dynamic> show(BuildContext context, Property property,
      Map<String, dynamic> data) async {
    var result = await AppNavigator.showAppDialogEx(
        context, () => PopupPropertyComponent(property: property, data: data),
        title: property.nameAr,
        size: DialogBoxSizes.small,
        actions: [
          IconButton(
            icon: Icon(Icons.done),
            onPressed: () {
              Navigator.pop(context, data[property.dbName]);
            },
          )
        ]);
    return result;
  }

  @override
  _PopupPropertyComponentState createState() => _PopupPropertyComponentState();
}

class _PopupPropertyComponentState extends State<PopupPropertyComponent> {
  void _valueChanged(dynamic val) {
    widget.data[widget.property.dbName] = int.parse(val);
  }

  @override
  Widget build(BuildContext context) {
    switch (widget.property.propertyType) {
      case PropertyTypes.Text:
        return _getText();
      default:
        return _getText();
    }
  }

  Widget _getText() {
    return TextFormField(
      autofocus: true,
      onChanged: _valueChanged,
      onFieldSubmitted: (v) {
        _valueChanged(v);
        Navigator.pop(context, widget.data[widget.property.dbName]);
      },
    );
  }
}
